/*
    GPRS/GSM/GPS Quadband Module (SIM908)
    TO CONTROL DEVICES FROM
    Version:          0.1
    Design:            REZA
    Implementation:    REZA 
*/
#include <String.h>
#include "EEPROM.h"
#include <HardwareSerial.h>

HardwareSerial sim900(1);


int8_t answer; int i, p; int cn, ct;
String answer1, pros;
int a = 0;
int x; int k = 0; int lo;
int j = 0; int l = 1; int q = 1;
char incoming_char = 0;
int anglt, gp, pr, anglm;
//===============dc drive========
int IN1 = 18; // IN1 -> D18
int IN2 = 19; // IN2 -> D19

//===============encoder==============
#define encoder0PinA 34 // GREEN ->D34
#define encoder0PinB 35 // WHITE ->D35

//===============limit sw=============
int CL = 12; // CLOSED -> D7
int OP = 13; // OPENED -> D8

//================POWER ON GSM========
int onModulePin = 23; // POWER ON GSM MODULE

//====================================
char aux_string[30]; char pro[1];
char SMS[200]; byte s1 = 0; byte s2 = 0;
char RMN[15] = "11111111111111" ;
char RN[15] = "1111111111111" ;
char sms_text[] = "Reza";
//char pin[] = "****";
//char resp[100];

//====================================
static volatile int encoder0Pos, prr, gpr, dpr = 0;
void IRAM_ATTR doEncoderA() {
  // look for a low-to-high on channel A

  if (digitalRead(encoder0PinA) == HIGH) {
    // check channel B to see which way encoder is turning
    if (digitalRead(encoder0PinB) == LOW) {
      encoder0Pos = encoder0Pos + 1;         // CW
    }

    else {
      encoder0Pos = encoder0Pos - 1;         // CCW

    }
  }

  else   // must be a high-to-low edge on channel A
  {

    // check channel B to see which way encoder is turning
    if (digitalRead(encoder0PinB) == HIGH) {
      encoder0Pos = encoder0Pos + 1;          // CW
    }
    else {
      encoder0Pos = encoder0Pos - 1;          // CCW
    }
  }
}
void IRAM_ATTR doEncoderB() {
  // look for a low-to-high on channel B
  if (digitalRead(encoder0PinB) == HIGH) {
    // check channel A to see which way encoder is turning
    if (digitalRead(encoder0PinA) == HIGH) {
      encoder0Pos = encoder0Pos + 1;         // CW
    }
    else {
      encoder0Pos = encoder0Pos - 1;         // CCW
    }
  }

  // Look for a high-to-low on channel B
  else {
    // check channel B to see which way encoder is turning
    if (digitalRead(encoder0PinA) == LOW) {
      encoder0Pos = encoder0Pos + 1;          // CW
    }
    else {
      encoder0Pos = encoder0Pos - 1;          // CCW
    }
  }
}
//====================================

void setup() {

  Serial.begin(9600);
  sim900.begin(9600, SERIAL_8N1, 16, 17);
  EEPROM.begin(1024);
  Serial.println("  ");
  Serial.println("==================Reset======================");

  anglt = EEPROM.readInt(10);
  anglm = EEPROM.readInt(20);
  gp = EEPROM.readInt(30);
  Serial.println(anglt);
  Serial.println(anglm);
  Serial.println(gp);
  pinMode(onModulePin, OUTPUT);
  pinMode(IN1, OUTPUT);
  pinMode(IN2, OUTPUT);
  digitalWrite(IN1, LOW);
  digitalWrite(IN1, LOW);
  digitalWrite(onModulePin, HIGH);

  pinMode(encoder0PinA, INPUT);
  pinMode(encoder0PinB, INPUT);

  void doEncoderA();
  void doEncoderB();

  // encoder pin on interrupt 0 (pin 2)
  attachInterrupt(34, doEncoderA, RISING);

  // encoder pin on interrupt 1 (pin 3)
  attachInterrupt(35, doEncoderB, RISING);

  Serial.println("Starting...");

  power_on();

  delay(1000);
  Serial.println("Setting SMS mode...");
  sendATcommand("AT+CMGF=1", "OK", 1000);    // sets the SMS mode to text
  sendATcommand("AT+CPMS=\"SM\",\"SM\",\"SM\"", "OK", 1000);    // selects the memory
  sendATcommand("AT+CMGD=1,4", "OK", 1000);
}

//+++++++++++++++++++++LOOP++++++++++++++++++++++++++++++++

void loop() {
  // smsread();
  incoming_char = sim900.read();
  if (incoming_char == '+') {
    delay(10);
    incoming_char = sim900.read();
    if (incoming_char == 'C') {
      smsread();
    }
  }
  if ( (digitalRead(OP) == HIGH)) {
    //  Serial.println("CALIB");
    pr = 10;
    gc();
  }
  delay(500);
  //Serial.println("LOOP");
  //Serial.println(digitalRead(CL));
}

//+++++++++++++++++++++POWER-ON+++++++++++++++++++++++++++++

void power_on() {

  uint8_t answer = 0;
  Serial.println("power_on");
  // checks if the module is started
  answer = sendATcommand("AT", "OK", 2000);
  answer1 = String(answer);
  //Serial.println(answer1);
  if (answer1 == "0")
  {
    // power on pulse
    //Serial.println("ON");
    digitalWrite(onModulePin, LOW);
    delay(3000);
    digitalWrite(onModulePin, HIGH);

    // waits for an answer from the module
    //    while (answer1 == "0") {   // Send AT every two seconds and wait for the answer
    //      answer = sendATcommand("AT", "OK", 2000);
    //      Serial.println("while+on");
    //      answer1 = String(answer);
    //      Serial.println(answer1);
    //    }
  }
}
// ++++++++++++++++++++++++++AT-COMMAND++++++++++++++++++++++++++++++++++

int8_t sendATcommand(char* ATcommand, char* expected_answer, unsigned int timeout) {

  uint8_t x = 0,  answer = 0;
  char response[100];
  unsigned long previous;

  memset(response, '\0', 100);    // Initialice the string

  delay(100);

  while ( sim900.available() > 0) sim900.read();   // Clean the input buffer

  sim900.println(ATcommand);    // Send the AT command


  x = 0;
  previous = millis();

  // this loop waits for the answer
  do {
    // if there are data in the UART input buffer, reads it and checks for the asnwer
    if (sim900.available() != 0) {
      response[x] = sim900.read();
      x++;
      // check if the desired answer is in the response of the module
      if (strstr(response, expected_answer) != NULL)
      {
        answer = 1;
      }
    }
    // Waits for the asnwer with time out
  } while ((answer == 0) && ((millis() - previous) < timeout));

  return answer;
}
//---------------------------SMS-READ-----------------------------------------
void smsread() {
  sim900.flush();
  // sets the PIN code
  // sprintf(aux_string, "AT+CPIN=%s", pin);
  // sendATcommand("AT+CMGF=1", "OK", 1000);    // sets the SMS mode to text
  //  sendATcommand("AT+CPMS=\"SM\",\"SM\",\"SM\"", "OK", 1000);    // selects the memory
  //Serial.println(answer);
  //  if (Serial.available() > 0) {
  //Serial.println(answer);
  answer = sendATcommand("AT+CMGR=1", "+CMGR:", 2000);    // reads the first SMS
  //   Serial.println(answer);
  //    if (Serial.available() > 0) {
  //      *ms_ptr = Serial.read();
  //      ms_ptr++;
  //      *ms_ptr = '\0';
  //      Serial.println(myString);
  //    }
  if (answer == 1)
  {
    answer = 0;
    //      while (Serial.available() == 0);
    // this loop reads the data of the SMS
    //Serial.println("do");
    x = 0;
    do {
      //  Serial.print(answer);
      // if there are data in the UART input buffer, reads it and checks for the asnwer
      // if (Serial.available() > 0) {
      SMS[x] = sim900.read();

      if (x > 1)
      {
        //Serial.print(SMS[p]);
        if (SMS[x - 1] == 'O' && SMS[x] == 'K') {
          a = 1;
          //  Serial.println("ok1");
          //   Serial.println(answer);
        }
      }
      x++;
      //Serial.println(x);
      // check if the desired answer (OK) is in the response of the module
      //        if (strstr(SMS, "OK") != NULL)
      //        {
      //          answer = 1;
      //          Serial.println("ok2");
      //        }
      //  }
    } while (a == 0);   // Waits for the asnwer with time out
    pro[0] = SMS[57];
    pro[1] = SMS[58];
    pros = String(pro).c_str();
    Serial.println(pros);
    //   SMS[x] = '\0';
    //      Serial.println("sms: ");
    a = 0;
    Serial.println(SMS);
    Serial.flush();
    sim900.flush();
    comp();
  }
  //  else
  //  {
  //    Serial.print("error ");
  //    Serial.println(answer, DEC);
  //    while (answer == 0) {
  //      if ( digitalRead(pin)==HIGH) {
  //   //  sendsms(sms_text);
  //    }
  //      answer = sendATcommand("AT+CMGR=1", "+CMGR:", 2000);
  //    }
  //  }
  Serial.flush();
  sim900.flush();
  //  }
}


//+++++++++++++++++++++++++++COMPARE++++++++++++++++++++++++++++
void comp()
{
  for (int i = 1; i <= 80; i++) {
    if (SMS[i] == '"') {
      j++;
    }
    if ( j >= 3 && j < 4) {
      RMN[k] = SMS[i + 1];
      k++;
    }
    if (j < 8) {
      lo = i + 4;
    }
  }
  RMN[13] = ' ';
  // Serial.print("Remote Number:");
  // Serial.println(RMN);

  for (int q = 0; q <= 12; q++) {
    if ( RN[q] == RMN[q]) {
      cn++;
    }
  }

  if ( cn == 13) {
    //  Serial.println("RMN=RN");
    if (  SMS[lo] == 'H' && SMS[lo + 1] == 'I') {
      // Serial.println("fuond hi");
      //  sendATcommand("AT+CMGD=1,4", "OK", 1000);
    }

    if ( j >= 8 && SMS[lo] == '1' && SMS[lo + 1] == '1' ) {
      //  Serial.println("fuond 11");
      //    digitalWrite(led, HIGH);   // set the LED off
      // sendATcommand("AT+CMGD=1,4", "OK", 1000);
      cw();
    }

    if ( j >= 8 && SMS[lo] == '1' && SMS[lo + 1] == '2') {
      // Serial.println("fuond 12");
      //    digitalWrite(led, LOW);   // set the LED on
      // sendATcommand("AT+CMGD=1,4", "OK", 1000);
      ccw();
    }

    if ( j >= 8  && SMS[lo] == 'G' && SMS[lo + 1] == 'C') {
      pro[0] = SMS[lo + 2];
      pro[1] = SMS[lo + 3];
      // Serial.println("gate open");
      pros = String(pro).c_str();
      //   Serial.println(pros);
      pr = pros.toInt();
      Serial.println(pr);
      gc();
    }

    // --------Calibration-----------
    if ( j >= 8  && SMS[lo] == 'C' && SMS[lo + 1] == 'A' && SMS[lo + 2] == 'L') {
      cal();
    }

  }
  sendATcommand("AT+CMGD=1,4", "OK", 1000);

  // Serial.println(cn);
  // Serial.println(RMN);
  //Serial.println(RN);
  //Serial.println(SMS);
  //Serial.println(sizeof(RMN));
  //Serial.println(sizeof(RN));
  cn = 0;
}
//==================================comp reset================================
void comprs()
{
  for (int i = 1; i <= 80; i++) {
    if (SMS[i] == 'O' && SMS[i + 1] == 'K') {
      answer = 1;
    }
  }
  Serial.println("comp reset");
}
//==========================================SEND-SMS=================================
void sendsms(char *smstx) {
  Serial.println("Setting SMS mode...");
  sendATcommand("AT+CMGF=1", "OK", 1000);    // sets the SMS mode to text
  Serial.println("Sending SMS");

  sprintf(aux_string, "AT+CMGS=\"%s\"", RN);
  answer = sendATcommand(aux_string, ">", 4000);    // send the SMS number
  if (answer == 1)
  {
    Serial.println(smstx);
    Serial.write(0x1A);
    answer = sendATcommand("", "OK", 20000);
    if (answer == 1)
    {
      Serial.print("Sent ");
    }
    else
    {
      Serial.print("error ");
    }
  }
  else
  {
    Serial.print("error ");
    Serial.println(answer, DEC);
  }

}

//============================motor motion======================================
void cw() {
  digitalWrite(IN1, HIGH);
  digitalWrite(IN2, LOW);
}
void ccw() {
  digitalWrite(IN1, LOW);
  digitalWrite(IN2, HIGH);
}
void stp() {
  digitalWrite(IN1, LOW);
  digitalWrite(IN2, LOW);
}
//==============================gate control====================================
void gc() {
  void doEncoderA();
  void doEncoderB();
  int dpr = 0;
  int z = 0;
  encoder0Pos = (int)(gp / anglm);
  gpr = gp;
  prr = pr * 10000;
  Serial.print("encoder0Pos:"); Serial.println(encoder0Pos);
  if (prr < gpr) {
    cw();
    do {
      gpr = (int)(abs(encoder0Pos) * anglm) ;
      dpr = gpr - prr;
      Serial.println("pr < gp");
      Serial.print("gp:"); Serial.println(gpr);
      Serial.print("dp:"); Serial.println(dpr);
      yield();
    } while (dpr  == 0);
    stp();
    Serial.println(gpr);
  }
  if (prr > gpr) {
    ccw();
    Serial.println("pr > gp");
    while (prr != gpr); {
      gpr = (int)(abs(encoder0Pos) * anglm);
    //  dpr = prr - gpr;
      Serial.println("pr > gp");
      Serial.print("gp:"); Serial.println(gpr);
      Serial.print("dp:"); Serial.println(dpr);
      yield();
    }
    Serial.print("gp:"); Serial.println(gpr);
    stp();
  }
  Serial.print("encoder0Pos:"); Serial.println(encoder0Pos);
  encoder0Pos = 0;
  EEPROM.writeInt(30,  gp);
  EEPROM.commit();
}
//==============================gate calibration====================================
void cal() {
  void doEncoderA();
  void doEncoderB();
  int angl2, angl1;
  encoder0Pos = 0;

  do {
    ccw();
    yield();
  } while (digitalRead(CL) == LOW);

  stp();
  Serial.println(encoder0Pos);
  angl1 = abs(encoder0Pos);
  encoder0Pos = 0;
  delay(1000);

  do {
    cw();
    yield();
  } while (digitalRead(OP) == LOW);

  stp();
  Serial.println(encoder0Pos);
  angl2 = abs(encoder0Pos);
  anglt = angl1 + angl2;
  Serial.println(anglt);
  encoder0Pos = 0;
  delay(1000);
  while (abs(encoder0Pos) != anglt) {
    ccw();
    yield();
  }
  stp();
  Serial.println(encoder0Pos);
  EEPROM.writeInt(10, anglt);
  Serial.println(anglt);
  EEPROM.commit();
  // Serial.println(readEEPROM(100));
  anglm = 1000000 / anglt;
  EEPROM.writeInt(20, anglm);
  // EEPROM.commit();
  gp = 0;
  EEPROM.writeInt(30,  gp);
  EEPROM.commit();
  ESP.restart();
}
